/******************************************************************************************
Description: 	Stored Process to accept a ddcf plan

Creation Date: 	May 2011

Input parameters : planId

******************************************************************************************/


/*options mprint mlogic symbolgen;	*/
/* ***************** For creating logs****************************/
data _null_;
	call symputx('VarDtStr',TRANWRD(('_'|| put(date(),YYMMDDN.) || '_' || put(time(),HHMM.) || '.log'),':','_'));
run;

%let logfilenm=accept%sysfunc(ktrim(&planid.))&VarDtStr.;
%let logfilepath=&GL_DDF_CONFIG_DIR_PATH./logs/;

proc printto log="&logfilepath.&logfilenm."; 
run;
/****************** For creating logs*********************/


%macro ddcf_accept_plan;

%if &GL_FRAMEWORK_DB_IND.=&GL_SHORT_NO. %then %do;
	libname uiart MYSQL  INSERTBUFF=&GL_MYSQL_INSERTBUFF. DBINDEX=YES bulkload = yes  MYSQL_PORT=3306 DBCONINIT = &GL_MYSQL_DBCONINIT.
	DATABASE=&GL_TRANS_DATABASE_NM. SERVER="&GL_TRANS_DB_SERVER."  authdomain = &GL_MYSQL_AUTH_DOMAIN. ; 
%end;


%let plan_id= &planId;
%let accepted_before_ind =0;
%let consensus_exist = 0;

/* Define connection string for transactional server*/
%ddcf_connect_to_trans_db;

%ddcf_load_plan_analysis_var(process="diagnose");

%ddcf_populate_plan_reporting_tab(process="diagnose");

proc sql;
	update uiart.plan_details set PLAN_STATUS_NO = 8 where plan_id = &plan_id.;
quit;

%if &GL_FRAMEWORK_DB_IND.=&GL_SHORT_NO. %then %do;
	libname uiart clear;
%end;

%mend;

%ddcf_accept_plan;

proc printto; 
run;
