
%macro ddcf_delete_forecast_plan;

%if &GL_FRAMEWORK_DB_IND.=&GL_SHORT_NO. %then %do;
	libname uiart MYSQL  INSERTBUFF=&GL_MYSQL_INSERTBUFF. DBINDEX=YES bulkload = yes  ESCAPE_BACKSLASH=YES MYSQL_PORT=3306 DBCONINIT = &GL_MYSQL_DBCONINIT.
	DATABASE=&GL_TRANS_DATABASE_NM. SERVER="&GL_TRANS_DB_SERVER."  authdomain = &GL_MYSQL_AUTH_DOMAIN. ;
%end;

%global job_rc passwd GL_FS_PROJ_DESKTOP;

%let GL_FS_PROJ_DESKTOP=NO;

%local plan_id_count
		proj_id_count
		proj_error;
%let job_rc=0;

/* Define connection string for transactional server*/
%ddcf_connect_to_trans_db;

/*   create a table with the plan_ids applicable for the specific user */
proc sql noprint;
create table owner_spec_plan as
select plan_id from uiart.plan_operation
where kupcase(USER_NM)=kupcase("&userName.") and OPER_CD=0;
select count(*) into: plan_id_count
	          from owner_spec_plan;
quit;

%let plan_id_count=&plan_id_count;

%if &plan_id_count. >0 %then %do;


/* Initially show the status as 'deleting the plan' for all the plans applicable in plan_operation
	and plan_details table*/
	
	proc sql noprint;

		update uiart.plan_operation set OPER_STATUS = 14 where plan_operation.plan_id in 
		(select plan_id from owner_spec_plan) and kupcase(plan_operation.user_nm)=kupcase("&userName.");

		update uiart.plan_details set PLAN_STATUS_NO = 14 where plan_details.plan_id in 
		(select plan_id from owner_spec_plan );

	quit;

	%do plan_counter=1 %to &plan_id_count.;

		data _null_;
		obsnum = input("&plan_counter.",best12.); 
		set owner_spec_plan point = obsnum; 
			call symputx('plan_id',plan_id);
		stop;
		run;
/*   Create a table with the project ids applicable for the plan id*/
		proc sql noprint;
			create table project_spec as
			select distinct PROJECT_ID from uiart.fs_proj_analyze a 
				where a.plan_id=&plan_id. ;
/*				and project_status <= 6;*/
			select count(*) into: proj_id_count
			     from project_spec;
		quit;

		%let proj_id_count=&proj_id_count.;

		%if &proj_id_count. > 0 %then %do;

			data project_spec_mod;
			set project_spec;
			length user_nm $40.;
			user_nm="&userName.";
			OPER_CD=1;
			OPER_STATUS=0;
			run;


			proc sql noprint;

			insert into uiart.fs_proj_operation
			select PROJECT_ID,user_nm,OPER_CD,OPER_STATUS
			from project_spec_mod ;

			quit;

			%ddcf_del_fs_projects;

			proc sql noprint;
				select count(*) into: proj_error
			     from uiart.fs_proj_analyze 
			where plan_id=&plan_id.;
			
			quit;
			%put &proj_error;
			%let proj_error=&proj_error.;
	/* if any error has occured while deletion of fs proj then go to end and update the 
			plan_operation and plan_details table as 'error while deletion'*/
			%if &proj_error.>0 %then %do;	
			
				%goto end_;

			%end;
			
		%end;

		%ddcf_delete_plan_abt(id_to_del=&plan_id.);
		%ddcf_delete_plan_control(id_to_del=&plan_id.);
		%ddcf_delete_plan_scratch(id_to_del=&plan_id.);
		%ddcf_delete_plan_planexpl(id_to_del=&plan_id.);
		%ddcf_delete_plan_config(id_to_del=&plan_id.);
		%ddcf_delete_plan_uiart(id_to_del=&plan_id.);
		%ddcf_delete_folders(id_to_del=&plan_id.);

		/* Delete attribute temporary table */

		%let table_exist = %sysfunc(exist(scratch.p_h_a_&plan_id._tmp3));
    	%if &table_exist. eq 1 %then %do;
			proc datasets library=scratch nolist;
				delete p_h_a_&plan_id._tmp3;
			quit;
			%rcset(&syserr);
			%if &job_rc. > 4 %then %do;
				%put "Error: Failed while deleting attribute temporary tables for dual selector."; 
			%end;
		%end;

		/* if no error has occured then delete the row of plan_operation specific for the plan_id*/

		%if &job_rc. <6 %then %do;

			proc sql noprint;
				delete
	      		from uiart.plan_operation
	      		where plan_id=&plan_id. 
				and kupcase(user_nm)=kupcase("&userName.");

				delete
				from uiart.plan_details
				where plan_id= &plan_id.;
			quit;
			
			/* Deleting smart object associated with the forecast plan	*/

			%let TextType = FP;
			%put &TextType.;

			data _null_;
			      length temp $17;
			      /*resolve the ID of the object to be deleted*/
			      rc=metadata_resolve("omsobj:Document?@Name='&plan_nm.' and @TextType='&TextType.'","Id",temp);
			      call symputx('temp', temp);
			run;

			data _null_;

/*			      put "&temp.";*/
			      /*As smart objects are stored under Document in metadata give the ID selected above as input to delete*/
			      rc=metadata_delobj("omsobj:Document/&temp.");
/*			      put rc=;*/
			run;


		%end;
/* Else show error status*/
		%else %do;
		proc sql noprint;

		delete
      	from uiart.plan_operation
      	where plan_id=&plan_id. 
		and kupcase(user_nm)=kupcase("&userName.");

		update uiart.plan_details set PLAN_STATUS_NO= 15 where plan_id=&plan_id.;

		quit;

		%end;
		
		%end_:

			proc sql noprint;
				delete
	      		from uiart.plan_operation
	      		where plan_id=&plan_id. 
				and kupcase(user_nm)=kupcase("&userName.");

				update uiart.plan_details set PLAN_STATUS_NO= 15 where plan_id=&plan_id.;
			quit;
	%end;
%end;

/*Deleting work tables*/
		proc datasets lib=work kill nolist nowarn memtype = (data view);
		run; 
		quit;

%if &GL_FRAMEWORK_DB_IND.=&GL_SHORT_NO. %then %do;
	libname uiart clear;
%end;

%mend ddcf_delete_forecast_plan ;


%ddcf_delete_forecast_plan;
