/******************************************************************************************
Description: 	Stored Process to diagnose a ddcf plan

Creation Date: 	March 2011

Modified Date : April - Added macro call for Model table

Input parameters : 
NOTE:

ddcf_hpf_engine.sas file is present as uncompiled macro for customization purpose.
If necessary, the 'STOCHASTIC' statement can be replaced by 'CONTROL' statement as given in the uncompiled version.
It can be saved in the server and the 'path of stored process file' needs to be included in the '%include' statement below and line should be uncommented.
The EXTEND option can be changed from 'AVERAGE' to NONE, FIRST, LAST, MEDIAN, STOCHASTIC, MINIMUM, MAXIMUM.
***********************************************************************************************/
/*%include "path of stored process file\ddcf_hpf_engine.sas";*/


%macro ddcf_diagnose_forecast_plan;

%if &GL_FRAMEWORK_DB_IND.=&GL_SHORT_NO. %then %do;
	libname uiart MYSQL  INSERTBUFF=&GL_MYSQL_INSERTBUFF. DBINDEX=YES bulkload = yes  MYSQL_PORT=3306 DBCONINIT = &GL_MYSQL_DBCONINIT.
	DATABASE=&GL_TRANS_DATABASE_NM. SERVER="&GL_TRANS_DB_SERVER."  authdomain = &GL_MYSQL_AUTH_DOMAIN. ; 
%end;

%global adhoc_process_flg PLAN_VALID_DATA_FLG;
%let adhoc_process_flg=&GL_SHORT_YES.;
%local plan_status ;

%Global rediagnose_flg;

%global call_from_forecast;
%let call_from_forecast = &GL_SHORT_YES.;

/* Define connection string for transactional server*/
%ddcf_connect_to_trans_db;

/*%if &GL_OPT_FLAG. eq &GL_SHORT_YES. %then %do;*/

		%global drive_nm FORECAST_METHOD;
		%let drive_nm = &GL_DATA_STORAGE_PATH.;
        %let FORECAST_METHOD = HPF;
        %ddcf_plan_spec;
	%ddcf_call_set_params_libnames;
    
	        /* Change 25th July. */
	 		%let table_exist = %sysfunc(exist(_hpf0.est));
			%let table_exist1 = %sysfunc(exist(_hpf0.est0));

            %if &GL_OPT_FLAG. ne &GL_SHORT_YES. %then %do;

	            %if &table_exist. eq 1 %then %do;
	               %let rediagnose_flg = 1;
	            %end;
	            %else %do;
	               %let rediagnose_flg = 0;
	            %end; 

			%end;
			%else %do;

              %if &table_exist. eq 1 %then %do;
	              %let rediagnose_flg = 1;
	          %end;
			  %else %if &table_exist1. eq 1 %then %do;
                  %let rediagnose_flg = 1;
			  %end;
			  %else %do;
                  %let rediagnose_flg = 0;
			  %end;

			%end;
/*%end; */

/* Update plan and time series specific parameter in hpf_preference&plan_id table*/
%ddcf_update_hpf_param_for_proc 

/*   option sascmd="!sascmd -memsize 3G";*/

  option autosignon=YES sascmd="!sascmd";

/* Forecasting Store Proc */

/* added to handle multiple parallel processing */
%if &GL_OPT_FLAG. eq &GL_SHORT_YES. %then %do;
%ddcf_bef_ent_mp_connect(lib =scratch , file =connect_flg , column =flag );
%end;

%ddcf_call_diagnose_engine_mac;

/* Only in case, the optimization flag is set to Y, signoff is required.*/
 
 %if &GL_OPT_FLAG. eq &GL_SHORT_YES. %then %do;

 %ddcf_signoff_statements;

 %ddcf_immediate_after(lib =scratch , file = connect_flg, column = flag); 


 %end; 

/* Reconcile Store Proc */
%ddcf_call_reconcile_mac;


%if &GL_OPT_FLAG. eq &GL_SHORT_YES. %then %do;

		%global drive_nm FORECAST_METHOD;
		%let drive_nm = &GL_DATA_STORAGE_PATH.;
        %let FORECAST_METHOD = HPF;
	%ddcf_call_set_params_libnames;
 
%end; 

/*Updating UIARTs*/
%ddcf_uiart_diag_fcst_plan_stp;

%if &GL_FRAMEWORK_DB_IND.=&GL_SHORT_NO. %then %do;
	libname uiart clear;
%end;

%mend ddcf_diagnose_forecast_plan;
%ddcf_diagnose_forecast_plan;
