
%macro ddcf_hpf_engine(task = ,
                       libref = ,
                       dataset = ,
                       indep_dataset = , 
                       data_counter =   );
 
  /* Initial forecast job run when the task is Select. */
  /* Note that there is a single outfor permanent dataset.
     All the outfor datasets which are results of HPF Engine 
     are temporary. */

        %Global diag_custom_model_file diag_corrected_custom_model_file  ;


	proc hpfengine DATA= &dataset. 

		  %if &indep_num>0 %then %do;
			auxdata=&indep_dataset.
		  %end;
		   BACK = &hpf_back.
	         %if &diag_custom_model_file. eq 1 OR
                     &diag_corrected_custom_model_file. eq 1 
                     %then %do;
				GLOBALSELECTION=Custom_model_spec&plan_id.			  
		   %end;											  
           %if %sysfunc(kupcase(&task.)) eq %sysfunc(kupcase(select)) %then %do;
               INEST = &libref..est&data_counter.
           %end;
           %else %do;
               INEST = &libref..outest&data_counter.
           %end; 
/*		   %if &event_count>0 %then %do;*/
		   		%if  "&events_exists_flag." = "1" %then %do;
					INEVENT=Work.Eventrepository           								
		  		 %end;
/*		   %end;*/

			LEAD = &hpf_lead.
	       	MODELREPOSITORY = &libref..levmodrep&data_counter.

           	OUT =  &libref..out&data_counter.
		  	OUTCOMPONENT =&libref..outcomponent&data_counter.
            %if %sysfunc(kupcase(&task.)) eq %sysfunc(kupcase(select)) %then %do;
		   	   OUTEST=&libref..outest&data_counter.
            %end;	
           	OUTFOR = &libref..outfor&data_counter.
		   	OUTINDEP =&libref..outindep&data_counter.
			/* added on 27th Feb */
			%if %sysfunc(kupcase(&task.)) eq %sysfunc(kupcase(select)) %then %do;
		   		OUTMODELINFO =&libref..outmodelinfo&data_counter. 
			%end;
		   	OUTPROCINFO=&libref..outprocinfo&data_counter.  					
			OUTSTAT = &libref..outstat&data_counter.
			OUTSTATSELECT =&libref..outstatselect&data_counter.

           	SEASONALITY = &hpf_seasonality.

			%if "&hpf_seasontest." = "0" %then %do;
			   %let season=None;
			%end;
			%else  %do;
			   %let season=(siglevel = &HPF_SeasonTest_siglevel.); 
			%end;


            TASK = &task.(alpha=&HPF_FORECAST_ALPHA. 
			              criterion = &HPF_CRITERION.
                          override
    					  seasontest=&season. 
                          intermittent=&HPF_DIAGNOSE_INTERMITTENT.
						  HOLDOUT=&HPF_HOLDOUT.
						  HOLDOUTPCT=&HPF_HOLDOUT_PCT.
						  MINOBS=(TREND=&HPF_MINOBS_TREND.)
						  MINOBS=(SEASON=&HPF_MINOBS_SEASON.)
						  MINOBS=&HPF_MINOBS_NONMEAN.
						)
			 ;

		     by plan_id &fcst_hierarchy_string.;

            ID START_DT 
			INTERVAL	= &sas_interval.
			ACCUMULATE 	= &hpf_id_accumulate.
			ALIGN 		= &hpf_id_align.
			END			= "&hpf_end"d
					
			SETMISSING 	= &hpf_id_setmissing.
     		START 		= "&hpf_start"d
			
			TRIMMISS 	= &hpf_id_trimmiss.
			ZEROMISS 	= &hpf_id_zeromiss.

			horizonstart="&HPF_HORIZON_START."D
		    ;

		FORECAST &kpi_variable_nm. /
/*					ACCUMULATE 	= &hpf_fcst_accumulate.*/
					SETMISSING 	= &hpf_fcst_setmissing.
        			TRIMMISS 	= &hpf_fcst_trimmiss.
		        	ZEROMISS 	= &hpf_fcst_zeromiss.
		   ;
			

			/* Separate statements for each variable*/
		%if &indep_num>0 %then %do;
	        %do indep_counter=1 %to &indep_num.;

				CONTROL &&indep_var&indep_counter. /

				EXTEND= AVERAGE
				SETMISSING 	= &&diag_input_setmissing&indep_counter.
				TRIMMISS 	= &&diag_input_trimmiss&indep_counter.
				ZEROMISS 	= &&diag_input_zeromiss&indep_counter.
				REPLACEMISSING
				;

			 %end;

			
		%end;



 	  run;

%mend ddcf_hpf_engine;
